Attribute VB_Name = "modShutdown"
Option Explicit

Private Declare Function LookupPrivilegeValue Lib "advapi32.dll" _
                         Alias "LookupPrivilegeValueA" ( _
                         ByVal lpSystemName As String, _
                         ByVal lpName As String, _
                         lpLuid As LARGE_INTEGER) As Long

Private Declare Function GetCurrentProcess Lib "kernel32" () As Long

Private Declare Function AdjustTokenPrivileges Lib "advapi32.dll" ( _
                         ByVal TokenHandle As Long, _
                         ByVal DisableAllPrivileges As Long, _
                         NewState As TOKEN_PRIVILEGES, _
                         ByVal BufferLength As Long, _
                         PreviousState As TOKEN_PRIVILEGES, _
                         ReturnLength As Long) As Long

Private Declare Function OpenProcessToken Lib "advapi32.dll" ( _
                         ByVal ProcessHandle As Long, _
                         ByVal DesiredAccess As Long, _
                         TokenHandle As Long) As Long

Private Declare Function InitiateSystemShutdown Lib "advapi32.dll" _
                         Alias "InitiateSystemShutdownA" ( _
                         ByVal lpMachineName As String, _
                         ByVal lpMessage As String, _
                         ByVal dwTimeout As Long, _
                         ByVal bForceAppsClosed As Long, _
                         ByVal bRebootAfterShutdown As Long) As Long

Private Const ANYSIZE_ARRAY = 1
Private Const TOKEN_ADJUST_PRIVILEGES = 32
Private Const TOKEN_QUERY = 8
Private Const SE_PRIVILEGE_ENABLED As Long = 2
Private Const SE_SHUTDOWN_NAME = "SeShutdownPrivilege"
Private Const SE_REMOTE_SHUTDOWN_NAME = "SeRemoteShutdownPrivilege"

Private Type LARGE_INTEGER
    lowpart As Long
    highpart As Long
End Type

Private Type LUID_AND_ATTRIBUTES
    pLuid As LARGE_INTEGER
    Attributes As Long
End Type

Private Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    Privileges(ANYSIZE_ARRAY) As LUID_AND_ATTRIBUTES
End Type

Public Function SystemDownReboot(ByVal ServerName As String, ByVal Message As _
    String, Optional ByVal RebootAfterShutdown As Boolean = False, Optional ByVal WaitTo As Long = 30) As Boolean

    Dim ret As Long
    Dim hToken As Long
    Dim tkp As TOKEN_PRIVILEGES
    Dim tkpOld As TOKEN_PRIVILEGES

    If OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES Or _
        TOKEN_QUERY, hToken) Then

        ret = LookupPrivilegeValue(vbNullString, SE_REMOTE_SHUTDOWN_NAME, tkp.Privileges( _
            0).pLuid)

        tkp.PrivilegeCount = 1
        tkp.Privileges(0).Attributes = SE_PRIVILEGE_ENABLED

        If AdjustTokenPrivileges(hToken, 0, tkp, LenB(tkpOld), tkpOld, ret) Then

            SystemDownReboot = InitiateSystemShutdown(ServerName, Message, WaitTo, 0&, CLng(Abs( _
                RebootAfterShutdown)))

        End If

    End If

End Function

